<ngx-spinner bdOpacity=0.9 bdColor="#333" size="medium" color="#fff" type="ball-atom" fullScreen="true">
  <p style="color: white"> Loading... Set timeout 500ms </p>
</ngx-spinner>

<div class="table-page">

  <div>
    <mat-form-field floatLabel="never">
      <input matInput placeholder="Search" (keyup)="doFilter()" [(ngModel)]="searchKey">
      <button mat-button matSuffix mat-icon-button aria-label="Clear" *ngIf="searchKey" (click)="onSearchClear()">
        <mat-icon>close</mat-icon>
      </button>
    </mat-form-field>
  </div>


  <div class="table mat-elevation-z8">
    <mat-table [dataSource]="dataSource" matSort>
      <ng-container matColumnDef="number">
        <mat-header-cell *matHeaderCellDef class="tabel-cell__number">
          №
        </mat-header-cell>
        <mat-cell *matCellDef="let user; let i = index" class="tabel-cell__number"> {{i + 1}} </mat-cell>
      </ng-container>

      <ng-container matColumnDef="id">
        <mat-header-cell *matHeaderCellDef mat-sort-header>
          User id
        </mat-header-cell>
        <mat-cell *matCellDef="let user"> {{user.id}} </mat-cell>
      </ng-container>

      <ng-container matColumnDef="fullName">
        <mat-header-cell *matHeaderCellDef mat-sort-header>
          Full Name
        </mat-header-cell>
        <mat-cell *matCellDef="let user"> {{user.fullName}} </mat-cell>
      </ng-container>

      <ng-container matColumnDef="created_at">
        <mat-header-cell *matHeaderCellDef mat-sort-header>
          Created_at </mat-header-cell>
        <mat-cell *matCellDef="let user"> {{user.created_at | date:'medium'}} </mat-cell>
      </ng-container>

      <ng-container matColumnDef="actions">
        <mat-header-cell *matHeaderCellDef></mat-header-cell>
        <mat-cell *matCellDef="let user">
          <button mat-stroked-button (click)='redirectToUser(user.id)'>User bookings</button>
        </mat-cell>
      </ng-container>

      <ng-container matColumnDef="loading">
        <mat-footer-cell *matFooterCellDef colspan="3"> Loading data... </mat-footer-cell>
      </ng-container>


      <mat-header-row *matHeaderRowDef="displayedColumns"></mat-header-row>
      <mat-row *matRowDef="let row; columns: displayedColumns;"></mat-row>
      <mat-footer-row *matFooterRowDef="['loading']" [ngClass]="{'hide': dataSource.data != null}"></mat-footer-row>
    </mat-table>

    <mat-paginator [pageSizeOptions]="[5,10,15,25]" [pageSize]="10" showFirstLastButtons></mat-paginator>
  </div>
</div>